#ifndef _MOTION_MODULE_H
#define _MOTION_MODULE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "motion_manager.h"

typedef struct TMotionModule{
  TModules id;
  TMotionManager *manager;
  void (*set_period)(void *module,unsigned short int period_ms);
  void (*set_module)(void *module,unsigned char servo_id);  
  void (*pre_process)(void *module);
  void (*post_process)(void *module);
  void *data;
}TMotionModule;

void mmodule_init(TMotionModule *module);

#ifdef __cplusplus
  }
#endif

#endif 
