#include "mem_module.h"
#include "memory.h"
#include <stdio.h>

void module1_init_mem(unsigned char init_eeprom)
{

}

void module1_write_cmd(unsigned short int start_address,unsigned short int length,unsigned char *data)
{

}

void module1_read_cmd(unsigned short int start_address,unsigned short int length,unsigned char *data)
{

}

void module2_init_mem(unsigned char init_eeprom)
{

}

void module2_write_cmd(unsigned short int start_address,unsigned short int length,unsigned char *data)
{

}

void module2_read_cmd(unsigned short int start_address,unsigned short int length,unsigned char *data)
{

}

int main(void)
{
  TMemory memory;
  TMemModule module1;
  TMemModule module2;

  mem_module_init(&module1);
  module1.write_cmd=module1_write_cmd;
  module1.read_cmd=module1_read_cmd;
  mem_module_init(&module2);
  module2.write_cmd=module2_write_cmd;
  module2.read_cmd=module2_read_cmd;
  mem_init(&memory);
  
  if(!mem_module_add_ram_segment(&module1,0x0000,0x0005))
    printf("Impossible to add segment\n");
  if(!mem_module_add_ram_segment(&module1,0x0055,0x000A))
    printf("Impossible to add segment\n");
  if(!mem_module_add_eeprom_segment(&module1,0x0100,0x0020))
    printf("Impossible to add segment\n");
  if(!mem_add_module(&memory,&module1))
    printf("Impossible to add module\n");

  if(!mem_module_add_ram_segment(&module2,0x0200,0x0005))
    printf("Impossible to add segment\n");
  if(!mem_module_add_eeprom_segment(&module2,0x0180,0x0020))
    printf("Impossible to add segment\n");
  if(!mem_add_module(&memory,&module2))
    printf("Impossible to add module\n");

  if(!mem_module_add_ram_segment(&module2,0x050,0x000A))
    printf("Impossible to add segment\n");
  if(!mem_module_add_eeprom_segment(&module2,0x0180,0x0030))
    printf("Impossible to add segment\n");
  if(!mem_add_module(&memory,&module2))
    printf("Impossible to add module\n");
}
